/* GCC */

#include <fstream>
#include <vector>
#include <cstring>
#define LONG unsigned long long

using namespace std;
const LONG noreach = 9223372036854775800ll;
const LONG noway = 9223372036854775801ll;

ifstream fin;
ofstream fout;
vector< vector<LONG> > Labirint;
long long bestFinish = noway;
int W, H;
int startX, startY, bestX, bestY;
vector<char> ToWrite;

inline void Input()
{
    fin.open("labirint.in");
    fin>>H>>W;
    vector<LONG> tmpV;
    string tmpS;
    getline(fin, tmpS);
    for(int h = 0; h < H; h++)
    {
        tmpV.clear();
        getline(fin, tmpS);
        for(int w = 0; w < W; w++)
        {   
            switch(tmpS[w])
            {
                case '+':
                    startX = w; startY = h; 
                case ' ':
                    tmpV.push_back(noreach);
                    break;
                default:  
                    tmpV.push_back(noway);
                    break;      
            }
        }
        Labirint.push_back(tmpV);
    }
    fin.close();       
}

inline void Walk(int x, int y, int c)
{
       if(Labirint[y][x] == noway || Labirint[y][x] <= c)
            return;
       
       Labirint[y][x] = c;
       
       if(!x || x == W - 1 || !y || y == H - 1)
       {
            if(bestFinish > c)
            {
               bestFinish = c;
               bestX = x;
               bestY = y;   
            }
            return;                  
       }
       
       c++;
       Walk(x+1, y, c);
       Walk(x-1, y, c);
       Walk(x, y+1, c);
       Walk(x, y-1, c);
}

inline void Output(int x, int y)
{
       if(!Labirint[y][x])
           return;
           
       if(Labirint[y][x] - 1 == Labirint[y+1][x])
       {
           ToWrite.push_back('n');
           Output(x, y+1);              
       }
       else if(Labirint[y][x] - 1 == Labirint[y-1][x])
       {
           ToWrite.push_back('s');
           Output(x, y-1); 
       }
       else if(Labirint[y][x] - 1 == Labirint[y][x+1])
       {
           ToWrite.push_back('w');
           Output(x+1, y); 
       }
       else 
       {
           ToWrite.push_back('e');
           Output(x-1, y); 
       }
}

int main()
{
    Input();
    Walk(startX, startY, 0);
    fout.open("labirint.out");
    if(bestFinish == noway)
         fout<<-1;              
    else if(!bestFinish)
         fout<<0;
    else
    {
         fout<<bestFinish<<endl;
         Output(bestX, bestY);  
         for(int i = ToWrite.size()-1; i >=0; i--)
             fout<<ToWrite[i];
    }
    fout<<endl;
    fout.close();
    return 0;   
}
